#!/usr/bin/php -q
<?php
require('dbconfig.php');
ini_set("error_reporting", "ALL");
ini_set('magic_quotes_gpc', 'off');
ini_set('register_globals', 'off');
ini_set('max_execution_time', 300);
ini_set("display_errors", 1);
date_default_timezone_set('America/Chicago');

function log_print_text($str) {
	global $logfilen;
	global $loglevel;
	global $new_script;
	if($loglevel >= 3 or !$new_script){$logfile = fopen($logfilen, 'a');} else {$logfile = fopen($logfilen, 'w');}
	fputs($logfile, "\r\n$str");
	fclose($logfile);
	$new_script = false;
}

function log_var_dump($v_array) {
	global $logfilen;
	global $loglevel;
	global $new_script;
	if($loglevel >= 3 or !$new_script){$logfile = fopen($logfilen, 'a');} else {$logfile = fopen($logfilen, 'w');}
   ob_start();
   var_dump($v_array);
   $out = ob_get_contents();
   ob_end_clean();
   fputs($logfile, "\r\n$out");
	fclose($logfile);   	
	$new_script = false;
}

function get_log_name() {
	global $_SERVER;
	global $logdir;
	global $args;
	global $arg0;
	global $arg1;
	global $arg2;
	global $arg3;
	
	$default = 'generic.php';
	if (isset($_SERVER['argv'])) {													// Start by assuming command line call.  First argument is program name
	   $args = $_SERVER['argv'];                                         	
	   if (isset($args[0])) {$arg0 = $args[0];} else {$arg0 = $default;}	// If argv is present but no name assign a generiv name.
	   if (isset($args[1])) {$arg1 = $args[1];} else {$arg1 = '%';}		// default in case no argument is passed.  Maybe an error message is in order
	   if (isset($args[2])) {$arg2 = $args[2];} else {$arg2 = 0;}			// default in case no argument is passed.  Maybe an error message is in order
	   if (isset($args[3])) {$arg3 = $args[3];} else {$arg3 = '';}			// default in case no argument is passed.  Maybe an error message is in order
	}
	else if (isset($_SERVER['REQUEST_URI'])) {									// If a server call, get the script name called.
		$arg0 = $_SERVER['REQUEST_URI'];
	}
	else {
		$arg0 = $default;																	// No other choice
	}	
	$tim1 = time();																		// Unix timestamp
	$date_log = date('mdY', $tim1);													// format for log file name
	$fn = basename($arg0, '.php');													// get base name of this file
	$logfilen = $logdir . strtolower($fn) . '-' . $date_log . '.log';		// form log filename with date
	return $logfilen;	
}

function fix_phone($text) {
   $trans = array("(" => "", ")" => "", " " => "", "." => "", "-" => "" );
   $text = trim($text);
   $text = strtr( $text, $trans);
   return $text;      
}

require('dbconfig.php');

$default_ip = '192.168.1.80'; 														// IP address needed for local test send
$default_area = '636';																								// Extract from $_SERVER variables if present
																								// otherwise use default IP address entered here.
if (isset($_SERVER['SERVER_ADDR'])) {$serverip = $_SERVER['SERVER_ADDR'];}  else {$serverip = $default_ip;}
$logfilen = get_log_name(); 															// Get log file name from this script name
$new_script = true;																		// First time so open a new file if not appending because of log level

$stdlog = fopen('/var/log/asterisk/get_doors.log', 'w');
$msg = "Starting: get_route";
log_print_text($msg);
log_var_dump($args);

$msg = "Using $dbhost $dbuser $dbpass";
log_print_text($msg);

$db_connection = @mysql_connect ($dbhost, $dbuser, $dbpass) or die (mysql_error());
$db_select = @mysql_select_db($dbname) or die (mysql_error());
$out_exten = $arg1;
$out_select = $arg2;
$in_cid = $arg3;

$found = false;
if($in_cid != ''){
	$qt = "select * from outbound_trunk where IN_CID like '$in_cid'";
	log_print_text($qt);
	$tresult = @mysql_query($qt);
	$trow_count = mysql_num_rows($tresult);
	if ($trow_count != 0 ) {
		$trow = @mysql_fetch_assoc($tresult);
		extract($trow);
		$found = true;
		$rm_area = 'N';
	}
}

if(!$found){
	$qt = "select * from outbound where MATCH_PATTERN like left('$out_exten', char_length(MATCH_PATTERN)) order by ID";
	log_print_text($qt);
	$result = @mysql_query($qt);
	$row_count = mysql_num_rows($result);
	$row = @mysql_fetch_assoc($result);
	
	if ($row_count != 0 ) {
	   $rm_area = trim($row['RM_AREA']);
	   $trunk_pri = trim($row['TRUNK_PRI']);
	   $trunk_sec1 = trim($row['TRUNK_SEC1']);
	   $trunk_sec2 = trim($row['TRUNK_SEC2']);
		log_print_text($out_exten);
		$out_route = $trunk_pri;
		if($out_select == 1){$out_route = $trunk_sec1;}
		else if($out_select == 2){$out_route = $trunk_sec2;}
	
	}
	else {
		$qt = "select * from outbound where MATCH_PATTERN like 'default'";
		log_print_text($qt);
		$result = @mysql_query($qt);
		$row_count = mysql_num_rows($result);
		$row = @mysql_fetch_assoc($result);
	   $rm_area = trim($row['RM_AREA']);
	   $trunk_pri = trim($row['TRUNK_PRI']);
	   $trunk_sec1 = trim($row['TRUNK_SEC1']);
	   $trunk_sec2 = trim($row['TRUNK_SEC2']);
		log_print_text($out_exten);
		$out_route = $trunk_pri;
		if($out_select == 1){$out_route = $trunk_sec1;}
		else if($out_select == 2){$out_route = $trunk_sec2;}
	}
	$qt = "select * from outbound_trunk where TRUNK like '$out_route' order by ID";
	log_print_text($qt);
	$tresult = @mysql_query($qt);
	$trow_count = mysql_num_rows($tresult);
	$trow = @mysql_fetch_assoc($tresult);
	extract($trow);
}


if($E164 == 'N'){
	if($rm_area == 'Y'){$out_exten = substr($out_exten, 3);}
}
else {
	$out_exten = '+1' . $out_exten;
}

$dial = $out_exten . '@' . $TECH_EXTEN;
if($TECH_EXTRA != ''){$dial = $dial . ',' . $TECH_EXTRA;}
$ret_array = array('Callerid' => $OUT_CID, 'Tech' => $TECH, 'Dial' => $dial);
$str = json_encode($ret_array);	
log_print_text($str);	

$stdout = fopen('php://stdout', 'w');
fputs($stdout, $str);

exit;
?>
